<?php
//automatic adjustment of track's laps
// ©2011 RamCUP2000
// version 1.3

Aseco::registerEvent('onStartup','r_autolaps_startup');
Aseco::registerEvent('onEndRace1', 'r_autolaps');
Aseco::addChatCommand('rautolaps', 'automatic setting of laps');

global $rautolaps;

function r_autolaps_startup($aseco){
global $rautolaps;

  $rautolaps = array();  
  $rautolaps['akt'] = 0;
  if($aseco->client->query('GetNbLaps')){ $nblaps = $aseco->client->getResponse();}
  $rautolaps['def'] = $nblaps['CurrentValue'];
}

function r_autolaps($aseco){
global $rautolaps, $jukebox;

if($rautolaps['akt'] == 1){
 if($aseco->server->gameinfo->mode == 3){
 
		  if(count($jukebox) > 0){
			  foreach($jukebox as $track){
				$tratinfo = $track;
				break;}
		  }
    	if($tratinfo != false){ $filename = $tratinfo['FileName'];}
      else{
      if($aseco->client->query('GetNextChallengeInfo')){ $tratinfo = $aseco->client->getResponse();}
        $filename = $tratinfo['FileName'];
      }
     $gbx = new GBXChallengeFetcher($aseco->server->trackdir.$filename, false);
     if($gbx->nblaps <= 1){ $gbx->nblaps = 1;}     
     $caskola = $gbx->authortm / $gbx->nblaps;
     $pocetkol = round(($rautolaps['cas'] * 60) / ($caskola / 1000));
     
     $chat = '$i$0f0<R-AutoLaps> $08fnext track\'s 1 lap is $fff'.formatTime($caskola).' $08fwill be set $fff'.$pocetkol.' lap(s) ~'.$rautolaps['cas'].' min $08f('.$rautolaps['aut'].')';
     $aseco->client->query('ChatSendServerMessage', $chat);
     
     $aseco->client->query('SetNbLaps', (int)$pocetkol);
  }
 }
}


function chat_rautolaps($aseco, $command){
global $rautolaps;
$command['params'] = explode(' ', $command['params']);
$autor = $command['author'];

if($aseco->isMasterAdmin($autor) || $aseco->isAdmin($autor)){
  if(($command['params'][0] == 'on') && ($rautolaps['akt'] == 0)){
    $rautolaps['akt'] = 1;
    if($command['params'][1] != null){
      $rautolaps['cas'] = (int)$command['params'][1];
    }
    else{
      $rautolaps['cas'] = 5;
    }
  $rautolaps['aut'] = stripColors($autor->nickname);
  $chat = '$i$0f0<R-AutoLaps> $fffACTIVATED$08f will be set $fff~'.$rautolaps['cas'].' min $08f('.stripColors($autor->nickname).')';
  $aseco->client->query('ChatSendServerMessage', $chat);
 }
  elseif(($command['params'][0] == 'off') && ($rautolaps['akt'] == 1)){
    $rautolaps['akt'] = 0;
    if($command['params'][1] != null){
      $pocetkol = $command['params'][1];
    }
    else{ $pocetkol = $rautolaps['def'];
    }
    $chat = '$i$0f0<R-AutoLaps> $fffDISABLED$08f will always set $fff'.$pocetkol.' lap(s) $08f('.stripColors($autor->nickname).')';
    $aseco->client->query('ChatSendServerMessage', $chat);
    $aseco->client->query('SetNbLaps', (int)$pocetkol);
  }
  else{
    $chat = '$i$0f0<R-AutoLaps> $08ffor activate this feature, use: $fff/rautolaps on [minutes] $08ffor disable this function, use: $fff/rautolaps off [number of laps]';
    $aseco->client->query('ChatSendServerMessageToLogin', $chat, $autor->login);
  }
}
else{
  $chat = '$i$0f0<R-AutoLaps> $08ffor this function you do not have the necessary rights';
  $aseco->client->query('ChatSendServerMessageToLogin', $chat, $autor->login);
}  
}
?>